Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode.Views/3.3/Plugin.cs.frame
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode.Views/3.3/Plugin.cs.frame	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode.Views/3.3/Plugin.cs.frame	(revision 10011)
@@ -34,6 +34,4 @@
     [PluginDependency("HeuristicLab.Core", "3.3")]
     [PluginDependency("HeuristicLab.Core.Views", "3.3")]
-    [PluginDependency("HeuristicLab.Optimization", "3.3")]
-    [PluginDependency("HeuristicLab.Operators", "3.3")]
     [PluginDependency("HeuristicLab.Common", "3.3")]
     [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/EnemyCollection.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/EnemyCollection.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/EnemyCollection.cs	(revision 10011)
@@ -37,6 +37,6 @@
 
     [StorableConstructor]
-    private EnemyCollection(bool deserializing) : base(deserializing) { }
-    private EnemyCollection(EnemyCollection original, Cloner cloner)
+    protected EnemyCollection(bool deserializing) : base(deserializing) { }
+    protected EnemyCollection(EnemyCollection original, Cloner cloner)
       : base(original, cloner) {
       RobocodePath = original.RobocodePath;
@@ -69,6 +69,5 @@
           robotList.SetItemCheckedState(robot, false);
         }
-      }
-      catch { }
+      } catch { }
 
       return robotList;
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Grammar.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Grammar.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Grammar.cs	(revision 10011)
@@ -20,5 +20,4 @@
 #endregion
 
-using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -31,8 +30,6 @@
   public class Grammar : SymbolicExpressionGrammar {
     [StorableConstructor]
-    private Grammar(bool deserializing) : base(deserializing) { }
-    private Grammar(Grammar original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected Grammar(bool deserializing) : base(deserializing) { }
+    protected Grammar(Grammar original, Cloner cloner) : base(original, cloner) { }
 
     public Grammar()
@@ -50,34 +47,33 @@
       #region Symbols
       var block = new Block();
-
-      var ifStmt = new IfStatement();
-      var elseStmt = new ElseStatement();
-      var whileLoop = new WhileLoop();
-
-      var numExpr = new NumericalExpression();
+      var stat = new Stat();
+      var ifStat = new IfStat();
+      var elseStat = new ElseStat();
+      var whileStat = new WhileStat();
+
+      var logicalExpr = new LogicalExpression();
+      var numericalExpr = new NumericalExpression();
+
+      var equal = new Equal();
+      var lessThan = new LessThan();
+      var lessThanOrEqual = new LessThanOrEqual();
+      var greaterThan = new GreaterThan();
+      var greaterThanOrEqual = new GreaterThanOrEqual();
+
+      var conjunction = new Conjunction();
+      var disjunction = new Disjunction();
+      var negation = new Negation();
+
+      var addition = new Addition();
+      var subtraction = new Subtraction();
+      var multiplication = new Multiplication();
+      var division = new Division();
+      var modulus = new Modulus();
+
       var number = new Number();
-      var numOp = new NumericalOperation();
-      var add = new Addition();
-      var sub = new Subtraction();
-      var mult = new Multiplication();
-      var div = new Division();
-      var mod = new Modulus();
-
-      var logicExpr = new LogicalExpression();
-      var logicComp = new LogicalComparison();
-      var numComp = new NumericalComparison();
-      var logicVal = new LogicalValue();
-      var not = new Negation();
-      var and = new Conjunction();
-      var or = new Disjunction();
-      var eq = new Equal();
-      var lt = new LessThan();
-      var gt = new GreaterThan();
-      var lteq = new LessThanOrEqual();
-      var gteq = new GreaterThanOrEqual();
+      var logicalVal = new LogicalValue();
 
       var ahead = new Ahead();
       var back = new Back();
-      var doNothing = new DoNothing();
       var fire = new Fire();
       var shotPower = new ShotPower();
@@ -108,69 +104,36 @@
       var onHitWall = new OnHitWall();
       var onScannedRobot = new OnScannedRobot();
-      var emptyEvent = new EmptyEvent();
 
       var run = new Run();
       var tank = new Tank();
-      var program = new Program();
+
+      var doNothing = new DoNothing();
+      var emptyEvent = new EmptyEvent();
       #endregion
 
       #region Symbol Collections
-      var numericalExpressions = new List<ISymbol>()
-            {
-                number, numOp, getEnergy, getGunHeading, getHeading, getRadarHeading, getX, getY
-            };
-
-      var numericalOperators = new List<ISymbol>()
-            {
-                add, sub, mult, div, mod
-            };
-
-      var logicalExpressions = new List<ISymbol>()
-            {
-                logicVal, logicComp, numComp, not
-            };
-
-      var logicalComparators = new List<ISymbol>()
-            {
-                and, or
-            };
-
-      var numericalComparators = new List<ISymbol>()
-            {
-                lt, gt, lteq, gteq, eq
-            };
-
-      var terminalSymbols = new List<ISymbol>()
-            {
-                doNothing, //getEnergy, getGunHeading, getHeading, getRadarHeading, getX, getY
-            };
-
-      var functionSymbols = new List<ISymbol>()
-            {
-                ahead, back, fire,
-                //setAdjustGunForRobotTurn, setAdjustRadarForGunTurn, setAdjustRadarForRobotTurn, 
-                turnGunLeft, turnGunRight, turnLeft, turnRadarLeft, turnRadarRight, turnRight
-            };
-
-      var constantSymbols = new List<ISymbol>()
-            {
-                shotPower
-            };
-
-      var eventSymbols = new List<ISymbol>()
-            {
-                run, onBulletHit, onBulletMissed, onHitByBullet, 
-                onHitRobot, onHitWall, onScannedRobot, block, emptyEvent
-            };
+      var eventSymbols = new ISymbol[] { onScannedRobot, onBulletHit, onBulletMissed, onHitByBullet, onHitRobot, onHitWall };
+      var controlSymbols = new ISymbol[] { ifStat, whileStat };
+      var functionSymbols = new ISymbol[] {
+        ahead, back, fire, turnGunLeft, turnGunRight, turnLeft, turnRadarLeft, turnRadarRight, turnRight
+        //setAdjustGunForRobotTurn, setAdjustRadarForGunTurn, setAdjustRadarForRobotTurn, 
+      };
+      var relationalOperators = new ISymbol[] { equal, lessThan, lessThanOrEqual, greaterThan, greaterThanOrEqual };
+      var logicalOperators = new ISymbol[] { conjunction, disjunction, negation };
+      var numericalExpressions = new ISymbol[] { number, getEnergy, getGunHeading, getHeading, getRadarHeading, getX, getY };
+      var numericalOperators = new ISymbol[] { addition, subtraction, multiplication, division, modulus };
       #endregion
 
       #region Adding Symbols
-      // add all symbols to the grammar
-
-      AddSymbol(ifStmt);
-      AddSymbol(elseStmt);
-      AddSymbol(whileLoop);
-
-      AddSymbol(numExpr);
+      foreach (var s in eventSymbols)
+        AddSymbol(s);
+      foreach (var s in controlSymbols)
+        AddSymbol(s);
+      foreach (var s in functionSymbols)
+        AddSymbol(s);
+      foreach (var s in relationalOperators)
+        AddSymbol(s);
+      foreach (var s in logicalOperators)
+        AddSymbol(s);
       foreach (var s in numericalExpressions)
         AddSymbol(s);
@@ -178,93 +141,102 @@
         AddSymbol(s);
 
-      AddSymbol(logicExpr);
-      foreach (var s in logicalExpressions)
-        AddSymbol(s);
-      foreach (var s in logicalComparators)
-        AddSymbol(s);
-      foreach (var s in numericalComparators)
-        AddSymbol(s);
-
-      foreach (var s in terminalSymbols)
-        AddSymbol(s);
+      AddSymbol(block);
+      AddSymbol(stat);
+      AddSymbol(elseStat);
+      AddSymbol(shotPower);
+      AddSymbol(logicalVal);
+      AddSymbol(logicalExpr);
+      AddSymbol(numericalExpr);
+      AddSymbol(run);
+      AddSymbol(tank);
+      AddSymbol(emptyEvent);
+      AddSymbol(doNothing);
+      #endregion
+
+      #region Grammar Definition
+      // StartSymbol
+      AddAllowedChildSymbol(StartSymbol, tank);
+
+      // Tank
+      AddAllowedChildSymbol(tank, run, 0);
+      AddAllowedChildSymbol(tank, onScannedRobot, 1);
+      AddAllowedChildSymbol(tank, onBulletHit, 2);
+      AddAllowedChildSymbol(tank, onBulletMissed, 3);
+      AddAllowedChildSymbol(tank, onHitByBullet, 4);
+      AddAllowedChildSymbol(tank, onHitRobot, 5);
+      AddAllowedChildSymbol(tank, onHitWall, 6);
+
+      // Run
+      AddAllowedChildSymbol(run, stat);
+
+      // Event
+      foreach (var s in eventSymbols)
+        AddAllowedChildSymbol(s, stat);
+
+      // Block
+      AddAllowedChildSymbol(block, stat);
+
+      // Stat
+      AddAllowedChildSymbol(stat, stat);
+      AddAllowedChildSymbol(stat, block);
+      foreach (var s in controlSymbols)
+        AddAllowedChildSymbol(stat, s);
       foreach (var s in functionSymbols)
-        AddSymbol(s);
-      foreach (var s in constantSymbols)
-        AddSymbol(s);
-      foreach (var s in eventSymbols)
-        AddSymbol(s);
-      AddSymbol(tank);
-      #endregion
-
-      #region Defining Grammar
-      // define grammar rules
-
-      // Branches
-      AddAllowedChildSymbol(ifStmt, logicExpr, 0);
-      AddAllowedChildSymbol(ifStmt, block, 1);
-      AddAllowedChildSymbol(ifStmt, elseStmt, 2);
-      AddAllowedChildSymbol(ifStmt, doNothing, 2);
-      AddAllowedChildSymbol(elseStmt, block);
-      AddAllowedChildSymbol(whileLoop, logicExpr, 0);
-      AddAllowedChildSymbol(whileLoop, block, 1);
+        AddAllowedChildSymbol(stat, s);
+      AddAllowedChildSymbol(stat, emptyEvent);
+      AddAllowedChildSymbol(stat, doNothing);
+
+      // IfStat
+      AddAllowedChildSymbol(ifStat, logicalExpr, 0);
+      AddAllowedChildSymbol(ifStat, stat, 1);
+      AddAllowedChildSymbol(ifStat, emptyEvent, 1);
+      AddAllowedChildSymbol(ifStat, doNothing, 1);
+      AddAllowedChildSymbol(ifStat, elseStat, 2);
+      AddAllowedChildSymbol(ifStat, emptyEvent, 2);
+      AddAllowedChildSymbol(ifStat, doNothing, 2);
+
+      // ElseStat
+      AddAllowedChildSymbol(elseStat, stat);
+      AddAllowedChildSymbol(elseStat, emptyEvent);
+      AddAllowedChildSymbol(elseStat, doNothing);
+
+      // WhileStat
+      AddAllowedChildSymbol(whileStat, logicalExpr, 0);
+      AddAllowedChildSymbol(whileStat, stat, 1);
+      AddAllowedChildSymbol(whileStat, emptyEvent, 1);
+      AddAllowedChildSymbol(whileStat, doNothing, 1);
 
       // Numerical Expressions
-      foreach (var s in numericalExpressions) {
-        AddAllowedChildSymbol(numExpr, s);
-        AddAllowedChildSymbol(numOp, s, 1);
-        AddAllowedChildSymbol(numOp, s, 2);
+      foreach (var s in numericalExpressions)
+        AddAllowedChildSymbol(numericalExpr, s);
+      foreach (var s in numericalOperators) {
+        AddAllowedChildSymbol(numericalExpr, s);
+        foreach (var ne in numericalExpressions)
+          AddAllowedChildSymbol(s, ne);
+        foreach (var no in numericalOperators) {
+          AddAllowedChildSymbol(s, no);
+        }
       }
-      foreach (var s in numericalOperators)
-        AddAllowedChildSymbol(numOp, s, 0);
 
       // Logical Expressions
-      foreach (var s in logicalExpressions) {
-        AddAllowedChildSymbol(logicExpr, s);
-        AddAllowedChildSymbol(not, s);
-        AddAllowedChildSymbol(logicComp, s, 1);
-        AddAllowedChildSymbol(logicComp, s, 2);
+      AddAllowedChildSymbol(logicalExpr, logicalVal);
+      foreach (var s in logicalOperators) {
+        AddAllowedChildSymbol(logicalExpr, s);
+        AddAllowedChildSymbol(s, logicalVal);
+        foreach (var lo in logicalOperators)
+          AddAllowedChildSymbol(s, lo);
+        foreach (var ro in relationalOperators)
+          AddAllowedChildSymbol(s, ro);
       }
-      foreach (var s in logicalComparators)
-        AddAllowedChildSymbol(logicComp, s, 0);
-      foreach (var s in numericalExpressions) {
-        AddAllowedChildSymbol(numComp, s, 1);
-        AddAllowedChildSymbol(numComp, s, 2);
-      }
-      foreach (var s in numericalComparators)
-        AddAllowedChildSymbol(numComp, s, 0);
-
-
-      // All Void Statements can appear in run or in an event handler or inside a block
-      foreach (var e in eventSymbols) {
-        AddAllowedChildSymbol(e, ifStmt);
-        AddAllowedChildSymbol(e, whileLoop);
-        AddAllowedChildSymbol(e, doNothing);
-        foreach (var f in functionSymbols)
-          AddAllowedChildSymbol(e, f);
-      }
-
-      // Add the appropriate parameters as children of their respective functions
+      foreach (var s in relationalOperators)
+        AddAllowedChildSymbol(s, numericalExpr);
+
+      // Functions
       foreach (var f in functionSymbols) {
         if (f is Fire)
           AddAllowedChildSymbol(f, shotPower);
         else
-          AddAllowedChildSymbol(f, numExpr);
-
+          AddAllowedChildSymbol(f, numericalExpr);
       }
-
-      // Add all Event Methods to Tank. Run and OnScannedEvent are not optional,
-      // so EmptyEvent cannot take their places
-
-      AddAllowedChildSymbol(tank, run, 0);
-      AddAllowedChildSymbol(tank, onScannedRobot, 1);
-      AddAllowedChildSymbol(tank, onBulletMissed, 2);
-      AddAllowedChildSymbol(tank, onHitByBullet, 3);
-      AddAllowedChildSymbol(tank, onHitRobot, 4);
-      AddAllowedChildSymbol(tank, onHitWall, 5);
-      AddAllowedChildSymbol(tank, onBulletHit, 6);
-      for (int i = 2; i < tank.MaximumArity; i++)
-        AddAllowedChildSymbol(tank, emptyEvent, i);
-
-      AddAllowedChildSymbol(StartSymbol, tank, 0);
       #endregion
     }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/HeuristicLab.Problems.Robocode-3.3.csproj
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/HeuristicLab.Problems.Robocode-3.3.csproj	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/HeuristicLab.Problems.Robocode-3.3.csproj	(revision 10011)
@@ -109,14 +109,17 @@
     <Compile Include="Solution.cs" />
     <Compile Include="Symbols\Event Methods\Events\EmptyEvent.cs" />
+    <Compile Include="Symbols\Logical Expressions\Logical Comparators\ILogicalComparator.cs" />
+    <Compile Include="Symbols\Numerical Expressions\Numerical Operators\INumericalOperator.cs" />
     <Compile Include="Symbols\Numerical Methods\INumericalMethod.cs" />
+    <Compile Include="Symbols\Stat.cs" />
     <Compile Include="Symbols\Void Methods\Ahead.cs" />
     <Compile Include="Symbols\Void Methods\Back.cs" />
     <Compile Include="Symbols\Block.cs" />
-    <Compile Include="Symbols\Branches\ElseStatement.cs" />
-    <Compile Include="Symbols\Branches\IfStatement.cs" />
-    <Compile Include="Symbols\Branches\WhileLoop.cs" />
+    <Compile Include="Symbols\Statements\ElseStat.cs" />
+    <Compile Include="Symbols\Statements\IfStat.cs" />
+    <Compile Include="Symbols\Statements\WhileStat.cs" />
     <Compile Include="Symbols\Logical Expressions\BooleanTreeNode.cs" />
-    <Compile Include="Symbols\Logical Expressions\Logical Comparators\Conjunction.cs" />
-    <Compile Include="Symbols\Logical Expressions\Logical Comparators\Disjunction.cs" />
+    <Compile Include="Symbols\Logical Expressions\Conjunction.cs" />
+    <Compile Include="Symbols\Logical Expressions\Disjunction.cs" />
     <Compile Include="Symbols\Logical Expressions\Logical Comparators\Equal.cs" />
     <Compile Include="Symbols\Logical Expressions\Logical Comparators\GreaterThan.cs" />
@@ -124,9 +127,7 @@
     <Compile Include="Symbols\Logical Expressions\Logical Comparators\LessThan.cs" />
     <Compile Include="Symbols\Logical Expressions\Logical Comparators\LessThanOrEqual.cs" />
-    <Compile Include="Symbols\Logical Expressions\LogicalComparison.cs" />
     <Compile Include="Symbols\Logical Expressions\LogicalExpression.cs" />
     <Compile Include="Symbols\Logical Expressions\LogicalValue.cs" />
     <Compile Include="Symbols\Logical Expressions\Negation.cs" />
-    <Compile Include="Symbols\Logical Expressions\NumericalComparison.cs" />
     <Compile Include="Symbols\Numerical Expressions\NumberTreeNode.cs" />
     <Compile Include="Symbols\Numerical Expressions\Number.cs" />
@@ -137,5 +138,4 @@
     <Compile Include="Symbols\Numerical Expressions\Numerical Operators\Subtraction.cs" />
     <Compile Include="Symbols\Numerical Expressions\NumericalExpression.cs" />
-    <Compile Include="Symbols\Numerical Expressions\NumericalOperation.cs" />
     <Compile Include="Symbols\CodeNode.cs" />
     <Compile Include="Symbols\Tank.cs" />
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/RobocodeProblem.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/RobocodeProblem.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/RobocodeProblem.cs	(revision 10011)
@@ -83,5 +83,5 @@
       robotList.RobocodePath = robocodeDir.Value;
 
-      Parameters.Add(new FixedValueParameter<IntValue>(MaxTankProgramDepthParameterName, "Maximal depth of the Robocode tank program.", new IntValue(6)));
+      Parameters.Add(new FixedValueParameter<IntValue>(MaxTankProgramDepthParameterName, "Maximal depth of the Robocode tank program.", new IntValue(10)));
       Parameters.Add(new FixedValueParameter<IntValue>(MaxTankProgramLengthParameterName, "Maximal length of the tank program.", new IntValue(1000)));
       Parameters.Add(new ValueParameter<Grammar>(TankGrammarParameterName, "Grammar for the tank program.", new Grammar()));
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Block.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Block.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Block.cs	(revision 10011)
@@ -20,5 +20,6 @@
 #endregion
 
-
+using System;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -29,5 +30,5 @@
   public class Block : CodeNode {
     public override int MinimumArity { get { return 1; } }
-    public override int MaximumArity { get { return 10; } }
+    public override int MaximumArity { get { return byte.MaxValue; } }
 
     [Storable]
@@ -38,13 +39,11 @@
 
     [StorableConstructor]
-    private Block(bool deserializing) : base(deserializing) { }
-    private Block(Block original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected Block(bool deserializing) : base(deserializing) { }
+    protected Block(Block original, Cloner cloner) : base(original, cloner) { }
 
     public Block()
       : base("Block", "A group of statements.") {
-      this.Prefix = "{\r\n\t";
-      this.Suffix = "\r\nexecute();\r\n}\r\n";
+      Prefix = "{";
+      Suffix = "}";
     }
 
@@ -54,8 +53,6 @@
 
     public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      string result = "";
-      foreach (ISymbolicExpressionTreeNode c in children)
-        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
+      string result = children.Aggregate(string.Empty, (current, c) => current + (Environment.NewLine + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Environment.NewLine + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/CodeNode.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/CodeNode.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/CodeNode.cs	(revision 10011)
@@ -20,5 +20,5 @@
 #endregion
 
-
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -35,24 +35,14 @@
     protected CodeNode(CodeNode original, Cloner cloner)
       : base(original, cloner) {
-      this.Prefix = original.Prefix;
-      this.Suffix = original.Suffix;
+      Prefix = original.Prefix;
+      Suffix = original.Suffix;
     }
     protected CodeNode(string name, string description)
       : base(name, description) {
+      Prefix = string.Empty;
+      Suffix = string.Empty;
     }
 
-    public override IDeepCloneable Clone(Cloner cloner) {
-      throw new System.NotImplementedException();
-    }
-
-    public override int MaximumArity {
-      get { throw new System.NotImplementedException(); }
-    }
-
-    public override int MinimumArity {
-      get { throw new System.NotImplementedException(); }
-    }
-
-    public abstract string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children);
+    public abstract string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children);
   }
 }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/EmptyEvent.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/EmptyEvent.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/EmptyEvent.cs	(revision 10011)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -37,14 +38,8 @@
 
     [StorableConstructor]
-    private EmptyEvent(bool deserializing) : base(deserializing) { }
-    private EmptyEvent(EmptyEvent original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected EmptyEvent(bool deserializing) : base(deserializing) { }
+    protected EmptyEvent(EmptyEvent original, Cloner cloner) : base(original, cloner) { }
 
-    public EmptyEvent()
-      : base("EmptyEvent", "This is a placeholder for an empty event.") {
-      this.Prefix = "";
-      this.Suffix = "";
-    }
+    public EmptyEvent() : base("EmptyEvent", "This is a placeholder for an empty event.") { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -52,6 +47,6 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return "";
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      return ";";
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnBulletHit.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnBulletHit.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnBulletHit.cs	(revision 10011)
@@ -20,4 +20,7 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -37,14 +40,13 @@
 
     [StorableConstructor]
-    private OnBulletHit(bool deserializing) : base(deserializing) { }
-    private OnBulletHit(OnBulletHit original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected OnBulletHit(bool deserializing) : base(deserializing) { }
+    protected OnBulletHit(OnBulletHit original, Cloner cloner) : base(original, cloner) { }
 
     public OnBulletHit()
       : base("OnBulletHit", "This method is called when one of your bullets hits another robot.") {
-      this.Prefix = "\r\npublic void onBulletHit(BulletHitEvent e) {\r\n";
-      this.Suffix = "\r\nexecute();\r\n}\r\n";
+      Prefix = "public void onBulletHit(BulletHitEvent e) {";
+      Suffix =
+@"execute();
+}";
     }
 
@@ -53,9 +55,7 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      string result = "";
-      foreach (ISymbolicExpressionTreeNode c in children)
-        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = children.Aggregate(string.Empty, (current, c) => current + (Environment.NewLine + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Environment.NewLine + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnBulletMissed.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnBulletMissed.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnBulletMissed.cs	(revision 10011)
@@ -20,4 +20,7 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -37,14 +40,13 @@
 
     [StorableConstructor]
-    private OnBulletMissed(bool deserializing) : base(deserializing) { }
-    private OnBulletMissed(OnBulletMissed original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected OnBulletMissed(bool deserializing) : base(deserializing) { }
+    protected OnBulletMissed(OnBulletMissed original, Cloner cloner) : base(original, cloner) { }
 
     public OnBulletMissed()
       : base("OnBulletMissed", "This method is called when one of your bullets misses, i.e. hits a wall.") {
-      this.Prefix = "\r\npublic void onBulletMissed(BulletMissedEvent e) {\r\n";
-      this.Suffix = "\r\nexecute();\r\n}\r\n";
+      Prefix = "public void onBulletMissed(BulletMissedEvent e) {";
+      Suffix =
+@"execute();
+}";
     }
 
@@ -53,9 +55,7 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      string result = "";
-      foreach (ISymbolicExpressionTreeNode c in children)
-        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = children.Aggregate(string.Empty, (current, c) => current + (Environment.NewLine + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Environment.NewLine + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnHitByBullet.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnHitByBullet.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Event Methods/Events/OnHitByBullet.cs	(revision 10011)
@@ -20,4 +20,7 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -37,14 +40,13 @@
 
     [StorableConstructor]
-    private OnHitByBullet(bool deserializing) : base(deserializing) { }
-    private OnHitByBullet(OnHitByBullet original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected OnHitByBullet(bool deserializing) : base(deserializing) { }
+    protected OnHitByBullet(OnHitByBullet original, Cloner cloner) : base(original, cloner) { }
 
     public OnHitByBullet()
       : base("OnHitByBullet", "This method is called when your robot is hit by a bullet.") {
-      this.Prefix = "\r\npublic void onHitByBullet(HitByBulletEvent e) {\r\n";
-      this.Suffix = "\r\nexecute();\r\n}\r\n";
+      Prefix = "public void onHitByBullet(HitByBulletEvent e) {";
+      Suffix =
+@"execute();
+}";
     }
 
@@ -53,9 +55,7 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      string result = "";
-      foreach (ISymbolicExpressionTreeNode c in children)
-        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = children.Aggregate(string.Empty, (current, c) => current + (Environment.NewLine + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Environment.NewLine + Suffix;
     }
   }
